//
//  MainViewController.h
//  Komakusa
//
//  Created by ユウスケ on 2012/09/14.
//  Copyright (c) 2012年 arms22. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import <AVFoundation/AVAudioSession.h>
#import "FlipsideViewController.h"

@class AudioSignalAnalyzer, FSKSerialGenerator, FSKRecognizer;

@interface MainViewController : UIViewController <FlipsideViewControllerDelegate,
    AVAudioSessionDelegate>
{
    AudioSignalAnalyzer *_analyzer;
    FSKSerialGenerator *_generator;
    FSKRecognizer *_recognizer;
    
    // Sensor Serial Protocol
    int   _sspState;
    int   _sspRecvDataLength;
    UInt8 _sspRecvData[32];
}

@property (strong, nonatomic) UIPopoverController *flipsidePopoverController;
@property (strong, nonatomic) IBOutlet UILabel *tempLabel;
@property (strong, nonatomic) IBOutlet UILabel *humidityLabel;
@property (strong, nonatomic) IBOutlet UILabel *dewPointLabel;

- (IBAction)showInfo:(id)sender;

@end
